/*
 * VideoSwitch.c
 *
 * Created: 06.01.2012 11:20:09
 *  Author: Philipp Kolb
 */ 

// Settings
#define POLLING_GRENZE 1 // Grenze ab wann logische 1
#define F_CPU 1000000UL //1MHZ default


#include <avr/io.h>
#include <avr/delay.h>



// Globale Variablen
uint8_t Eingang_PIN[8];


int main(void)
{
	
	// Startup
	
	// Ausgang B1-B6 (Video-Eingang 1 : B7)
	// Eingang D0-B0 (Taster 1 : D0 )
	DDRB = 0b111111110;
	
	DDRD = 0b0000000;
	
	PORTD = 0b1111111; //(Pullup aktiv)
	PORTB = 0b00000001;
	
	// Variablen
	int count_active;
	
	// Eternal Loop
	//#############
    while(1)
    {
		// Eingang Abfrage (ja man htte es auch mit einer Schleife eleganter lsen knnen...)
		
		if (PIND & (0b0000001)) { Eingang_PIN[0] = 0; } else { Eingang_PIN[0] = 1; } 
		if (PIND & (0b0000010)) { Eingang_PIN[1] = 0; } else { Eingang_PIN[1] = 1; }
		if (PIND & (0b0000100)) { Eingang_PIN[2] = 0; } else { Eingang_PIN[2] = 1; }
		if (PIND & (0b0001000)) { Eingang_PIN[3] = 0; } else { Eingang_PIN[3] = 1; }
		if (PIND & (0b0010000)) { Eingang_PIN[4] = 0; } else { Eingang_PIN[4] = 1; }
		if (PIND & (0b0100000)) { Eingang_PIN[5] = 0; } else { Eingang_PIN[5] = 1; }
		if (PIND & (0b1000000)) { Eingang_PIN[6] = 0; } else { Eingang_PIN[6] = 1; }
		if (PINB & (0b00000001)) { Eingang_PIN[7] = 0; } else { Eingang_PIN[7] = 1; }

		// Plausibilittsprfung (max ein Taster zur gleichen Zeit)
		count_active = 0;
		for (int s_n = 0; s_n < 8; s_n++ ){
			if (Eingang_PIN[s_n] == 1)
			{
				count_active = count_active + 1;
			}
		}		


	    // State Machine (bei 8 Abfragen lohnt sich keine for Schleife ;) )
		//##############
		
		if (count_active < 2) // bei mehreren Einsen keine Aktion durchfhren
		{
			if (Eingang_PIN[0] == 1) { PORTB = 0b00000001; } // Video Eingang 1
			if (Eingang_PIN[7] == 1) { PORTB = 0b00000011; } // Video Eingang 2
			if (Eingang_PIN[6] == 1) { PORTB = 0b00000101; } // Video Eingang 3
			if (Eingang_PIN[5] == 1) { PORTB = 0b00001001; } // Video Eingang 4
			if (Eingang_PIN[4] == 1) { PORTB = 0b00010001; } // Video Eingang 5
			if (Eingang_PIN[3] == 1) { PORTB = 0b00100001; } // Video Eingang 6
			if (Eingang_PIN[2] == 1) { PORTB = 0b01000001; } // Video Eingang 7
			if (Eingang_PIN[1] == 1) { PORTB = 0b10000001; } // Video Eingang 8
		}
		
		
		// Delay (fr pseudo Input Polling, Timer lohnt sich nicht fr diese Anwendung (wobei eigentlich ist das ganze auch nicht notwendig..))
		_delay_ms(150);
    }
}